<?php
/*
  Plugin Name: Banckle Chat for Wordpress
  Plugin URI: http://banckle.com
  Description: The most innovative and feature-complete online live support tool ever made. Banckle Chat can help business increase sales, boost productivity, and cut costs of support and customer service. Get more happier customers.
  Version: 1.3.6
  Author: Imran Anwar
  Author URI: http://banckle.com

  Copyright 2012  banckle.com  (email : imran.anwar@banckle.com)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License, version 2, as
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details at <http://www.gnu.org/licenses/>.
 */

$dir = get_option('siteurl') . '/' . PLUGINDIR . '/banckle-live-chat-for-wordpress/';

load_plugin_textdomain('bancleLiveChat', 'wp-content/plugins/banckle-live-chat-for-wordpress');


add_action('init', 'BanckleLiveChatInit');
add_action('wp_footer', 'BanckleLiveChatFooterScript');
//add_action('wp_header', 'BanckleLiveChatFooterScript');
add_action('admin_notices', 'BanckleLiveChatAdminNotice');

/**
 * Banckle Chat Widget
 */
class BanckleLiveChatWidget extends WP_Widget {

	 /** constructor */
	 function BanckleLiveChatWidget() {
		  parent::WP_Widget(false, $name = 'Banckle Chat Widget');
	 }

	 /** @see WP_Widget::widget */
	 function widget($args, $instance) {

		  if (get_option('BLCScript') && get_option('blcLocation')==="banckleLiveChatWidget") {
				$loc = get_option('blcLocation') === "" ? "banckleLiveChatBottomRight" : get_option('blcLocation');
				echo("\n<!-- Banckle Chat Code Start -->\n");
				echo("<script type='text/javascript' src='https://chat.banckle.com/chat/visitor.do?dep=" . get_option('BLCScript') . "'></script>");
				echo("<a href='#' onclick='blc_startChat();return false;'><img id='blc_chatImg' style='border:0px;' src='https://chat.banckle.com/chat/onlineImg.do?d=" . get_option('BLCScript') . "'></a>");
				echo("\n<!-- Banckle Chat Code End -->\n");
		  }
	 }

	 /** @see WP_Widget::update */
	 function update($new_instance, $old_instance) {
		  $instance = $old_instance;
		  return $instance;
	 }

	 /** @see WP_Widget::form */
	 function form($instance) {
		  	 if (!get_option('BLCScript'))
		  echo('<strong>' . sprintf(__('Banckle Chat is disabled. Please go to <a href="%s"> page</a> to enable it.'), admin_url('options-general.php?page=banckle-live-chat-for-wordpress')) . '</strong>');
	 }

}

add_action('widgets_init', create_function('', 'return register_widget("BanckleLiveChatWidget");'));

function banckleLiveChatRequest($url, $method="GET", $headerType="XML", $xmlsrc="") {

	 $method = strtoupper($method);
	 $headerType = strtoupper($headerType);
	 $session = curl_init();
	 curl_setopt($session, CURLOPT_URL, $url);
	 if ($method == "GET") {
		  curl_setopt($session, CURLOPT_HTTPGET, 1);
	 } else {
		  curl_setopt($session, CURLOPT_POST, 1);
		  curl_setopt($session, CURLOPT_POSTFIELDS, $xmlsrc);
		  curl_setopt($session, CURLOPT_CUSTOMREQUEST, $method);
	 }
	 curl_setopt($session, CURLOPT_HEADER, false);
	 if ($headerType == "XML") {
		  curl_setopt($session, CURLOPT_HTTPHEADER, array('Accept: application/xml', 'Content-Type: application/xml'));
	 } else {
		  curl_setopt($session, CURLOPT_HTTPHEADER, array("Content-Type: application/json"));
	 }
	 curl_setopt($session, CURLOPT_RETURNTRANSFER, true);
	 if (preg_match("/^(https)/i", $url))
		  curl_setopt($session, CURLOPT_SSL_VERIFYPEER, false);
	 $result = curl_exec($session);
	 curl_close($session);
	 return $result;
}

function BanckleLiveChatInit() {
	 if (function_exists('current_user_can') && current_user_can('manage_options')) {
		  add_action('admin_menu', 'BanckleLiveChatSettings');
		  add_action('admin_menu', 'BanckleCreateMenu');
	 }
}

function BanckleCreateMenu() {

	 //create new top-level menu
	 add_menu_page('Banckle Settings', 'Banckle Chat', 'administrator', 'BanckleLiveChatSettings', 'BanckleLiveChatSettings_page');
	 add_submenu_page('BanckleLiveChatSettings', 'Banckle Chat', 'Settings', 'administrator', 'BanckleLiveChatSettings', 'BanckleLiveChatSettings_page');
	 add_submenu_page('BanckleLiveChatSettings', 'Dashboard', 'Dashboard', 'administrator', 'banckleLiveChatDashboard', 'banckleLiveChatDashboard');
}

function banckleLiveChatDashboard() {

	 echo '<div id="dashboarddiv"><iframe id="dashboardiframe" src="http://apps.banckle.com/livechat" height=800 width=98% scrolling="no"></iframe></div>      <a href="http://apps.banckle.com/livechat" target="_newWindow" onClick="javascript:document.getElementById(\'dashboarddiv\').innerHTML=\'\'; ">Dashboard in a new window!</a>.
      ';
}

function BanckleLiveChatCustomError($errno, $errstr, $errfile, $errline) {
	 echo '<div class="wp-lc-login-form-error"> Oops, ' . $errstr . ' @ ' . $errline . '</div>';
}

function BanckleLiveChatFooterScript() {
?>
	 <style type="text/css">
	 	 #banckleLiveChatButton{position: fixed;vertical-align: middle;text-align: center;z-index:999999999 !important;}
	 	 .banckleLiveChatBottomLeft{bottom: 0px;left: 5px;}
	 	 .banckleLiveChatBottomRight{bottom: 0px;right: 22px;}
	 	 .banckleLiveChatTopLeft{top: 5px;left: 5px;}
	 	 .banckleLiveChatTopRight{top: 5px;right: 5px;}
	 	 #banckleLiveChatButton img{}
	 </style>
<?php
	 global $current_user;
	 if (get_option('BLCScript') && get_option('blcLocation')!=="banckleLiveChatWidget") {
		  $loc = get_option('blcLocation') === "" ? "banckleLiveChatBottomRight" : get_option('blcLocation');
		  echo("<div id='banckleLiveChatButton' class='" . $loc . "'>");
		  echo("\n<!-- Banckle Chat Code Start -->\n");
                  echo("<script type='text/javascript' async='async' defer='defer' src='https://chat.banckle.com/chat/visitor.do?dep=" . get_option('BLCScript') . "'></script>");
		  echo("<a href='#' onclick='blc_startChat();return false;'><img id='blc_chatImg' style='border:0px;' src='https://chat.banckle.com/chat/onlineImg.do?d=" . get_option('BLCScript') . "'></a>");
		  echo("\n<!-- Banckle Chat Code End -->\n");
		  echo("</div>");
	 }
}

function BanckleLiveChatAdminNotice() {
	 if (!get_option('BLCScript'))
		  echo('<div class="error"><p><strong>' . sprintf(__('Banckle Chat is disabled. Please go to <a href="%s"> page</a> to enable it.'), admin_url('options-general.php?page=banckle-live-chat-for-wordpress')) . '</strong></p></div>');
}

function BanckleLiveChatDeploymentForm($deptId, $deptName, $token, $loginId, $password) {
?>

	 <form method="post" action="options-general.php?page=banckle-live-chat-for-wordpress&action=deploy">
	 	 <div class="wp-lc-login-form">
	 		  <div class="wp-lc-login-form-btm">
	 				<div style="width: 580px; padding: 5px; margin: 0px auto; line-height:26px;">
	 					 <fieldset>
	 						  <legend>Deployment</legend>
	 						  <div class="row">
	 								<span class="label"><label>Deployment:</label></span>
	 								<span class="formw"><input value="New Deployment" type="text" name="deployment" id="deployment" style="width:275px"/></span>
	 						  </div>
	 						  <div class="row">
	 								<span class="label"><label>Title:</label></span>
	 								<span class="formw"><input value="Live Chat" type="text" name="title" id="title" style="width:275px"/></span>
	 						  </div>
	 						  <div class="row">
	 								<span class="label"><label>Copyright Text:</label></span>
	 								<span class="formw"><input value="Copyright is reserved by Banckle." type="text" name="copyright" id="copyright" style="width:275px"/></span>
	 						  </div>
	 					 </fieldset>
	 					 <fieldset>
	 						  <legend>Messages</legend>
	 						  <div class="row">
	 								<span class="label"><label>Invite:</label></span>
	 								<span class="formw"><textarea type="text" name="inviteMessage" id="inviteMessage" style="width:275px">Do you have any questions?</textarea></span>
	 						  </div>
	 						  <div class="row">
	 								<span class="label"><label>Online:</label></span>
	 								<span class="formw"><textarea type="text" name="welcomeMessage" id="welcomeMessage" style="width:275px">Welcome to Banckle</textarea></span>
	 						  </div>

	 						  <div class="row">
	 								<span class="label"><label>Offline:</label></span>
	 								<span class="formw"><textarea type="text" name="unavailableMessage" id="unavailableMessage" style="width:275px">Sorry, our service is unavailable now.</textarea></span>
	 						  </div>
	 						  <div class="row">
	 								<span class="label"><label>Waiting:</label></span>
	 								<span class="formw"><textarea type="text" name="waitingMessage" id="waitingMessage" style="width:275px">Please stand by while we connect you to the next available operator...</textarea></span>
	 						  </div>
	 						  <div class="row">
	 								<span class="label"><label>Exit:</label></span>
	 								<span class="formw"><textarea type="text" name="finalMessage" id="finalMessage" style="width:275px">Thank you for choosing Banckle.</textarea></span>
	 						  </div>
	 						  <div class="row">
	 								<span class="label"><label>Department:</label></span>
	 								<span class="formw"><input type="hidden" name="departments" id="departments" value="<?php echo $deptId; ?>" />
	 									 <input type="hidden" name="loginId" id="loginId" style="width:275px" value="<?php echo $loginId ?>"/>
	 									 <input type="hidden" name="password" id="password"  style="width:275px" value="<?php echo $password ?>"/>
	 									 <input type="hidden" name="token" id="token" value="<?php echo $token; ?>" style="width:275px"/>
	 									 <input disabled="true" type="text" name="deptName" id="deptName" value="<?php echo $deptName; ?>" style="width:275px"/>
	 								</span>
	 						  </div>
	 					 </fieldset>
	 					 <fieldset>
	 						  <legend>Appearance</legend>
	 						  <div class="row">
	 								<span class="label"><label>Position</label></span>
	 								<span class="formw"><select name="blcLocation" id="blcLocation"><option value="banckleLiveChatWidget">Widget</option><option value="banckleLiveChatTopLeft">Top Left</option><option value="banckleLiveChatTopRight">Top Right</option><option value="banckleLiveChatBottomLeft">Bottom Left</option><option value="banckleLiveChatBottomRight">Bottom Right</option></select> </span>
	 						  </div>
	 					 </fieldset>

	 					 <div class="row">
	 						  <span class="label">&nbsp;</span>
	 						  <span class="formw"><input type="submit" class="button-primary" value="Create Deployment" /></span>
	 					 </div>

	 				</div><!--width 580px; -->
	 		  </div><!--only for bottom bg -->
	 	 </div><!--wp-lc-login-form -->
	 </form>



<?php
}

function BanckleLiveChatSettings() {

	 function BanckleLiveChatSettings_page() {
		  global $dir;
		  set_error_handler("banckleLiveChatCustomError");
		  try {
?>

				<style>

					 .banckle-lc-wp-container{
						  border:1px solid #DBDBDB;
						  float:left;
						  padding:0px;
						  margin:0px;
						  width:798px;
						  position:relative;
					 }

					 .banckle-lc-wp-container IMG{ border:0px;}

					 .banckle-lc-wp-container h3{
						  clear:both;
						  display:block;
						  float:left;
						  padding: 10px 0px 0px 0px ;
						  margin:0px;
						  background: url(<?php echo($dir) ?>images/banckle-lc-wp-top1.gif) top left repeat-x;
						  height:42px;
						  text-indent:15px;
						  font-size:16px;
						  color:#333;
						  width:100%;
						  font-weight:bold;
					 }

					 .banckle-lc-wp-container-left{
						  display:inline;
						  float:left;
						  padding:10px;
						  margin:0px;
						  width:130px;
					 }

					 .banckle-lc-wp-container-right{
						  display:inline;
						  float:right;
						  width:620px;
						  padding:10px;
						  margin:0px;
						  _font:12px/20px Georgia, "Times New Roman", Times, serif;
						  color:#666;
					 }

					 OL{ margin:10px 0px;}
					 li{margin-left:30px;}

					 .banckle-lc-wp-container-right TEXTAREA{
						  border:1px inset #eee;
						  background:#F8F8F8;
						  padding:5px;
						  margin-left:0px;
						  margin-bottom:5px;
						  _height:100px;
						  _width:600px;
					 }
					 div.row {
						  clear: both;
						  padding-top: 5px;
					 }

					 div.row span.label {
						  float: left;
						  width: 240px;
						  text-align: right;
					 }

					 div.row span.formw {
						  float: left;
						  width: 235px;
						  text-align: left;
					 }

					 .steps3{
						  display:block;
						  clear:both;
						  float:left;
						  background:url(<?php echo($dir) ?>images/3steps.png) top left no-repeat #ccc;
						  width:646px;
						  height:148px;
						  margin-top:20px;
					 }
					 .steps3 UL{ padding:0px; margin:0px; margin-top:55px; font:12px/18px Arial, Helvetica, sans-serif}
					 .steps3 UL LI{ padding:0px; margin:0px; display:inline; float:left; width:190px; padding:0px 12px;  }

					 .postbox table.form-table{ margin-bottom:10px;}

					 .wp-lc-mesg-success{ display:block; clear:both; float:left; width:646px; padding:78px 0px 0px 0px; text-align: center; height:70px; background:url(<?php echo($dir) ?>images/bg_success.png) top left no-repeat #ccc; font:bold 12px arial}

					 .wp-lc-login{ display:block; clear:both; float:left; width:646px; padding:14px 0px 14px 0px; text-align: center; height:116px; background:url(<?php echo($dir) ?>images/bg_login.png) top left no-repeat #ccc; font:bold 12px arial}

					 .wp-lc-error{ display:block; clear:both; float:left; width:646px; padding:78px 0px 0px 0px; text-align: center; height:70px; background:url(<?php echo($dir) ?>images/bg_error.png) top left no-repeat #ccc; font:bold 12px arial}

					 .wp-lc-deploy{ display:block; clear:both; float:left; width:646px; padding:24px 0px 24px 0px; text-align: center; height:70px; background:url(<?php echo($dir) ?>images/bg_deployment.png) top left no-repeat #ccc; font:bold 12px arial}

					 .wp-lc-login-form{ display:block; clear:both; float:left; width:646px; padding:14px 0px 0px 0px; text-align: center; background:url(<?php echo($dir) ?>images/bg_logon_top.png) top left no-repeat #FEE180; font:bold 12px arial}
					 .wp-lc-login-form-btm{background:url(<?php echo($dir) ?>images/bg_logon_btm.png) bottom left no-repeat; float:left; padding-bottom:20px; width:100%}
					 .wp-lc-login-form-error{ display:block; clear:both; float:left; width:624px; padding:2px 10px; margin:4px 0px 4px 0px; text-align:left; background:#FFEBE8; border:1px solid #CC0000}

					 .wp-lc-login-form legend{ border-bottom: 1px solid #FEF3CC; clear: both; display: block; float: left; font: bold 14px arial;  margin: 15px 0px 5px 0px;  text-align: left;  width: 100%; background:#FEE9A5; padding:5px;}

					 fieldset {
						  margin: 1.5em 0 1.5em 0;padding: 0; /*background-color:#DBDBDB*/}
					 legend {
						  margin-left: 1em;
						  color: #000000;
						  font-weight: bold;
					 }



				</style>
				<div class="wrap">
	 <?php screen_icon() ?>
		  	 <script src='<?php echo($dir) ?>jquery.json-2.2.min.js'></script>
		  	 <h2>Banckle Chat</h2>
		  	 <div class="metabox-holder meta-box-sortables pointer">
		  		  <div class="postbox" style="float:left;width:57em;margin-right:20;">
		  				<h3 class="hndle" style="background: url(<?php echo($dir) ?>images/banckle-lc-wp-top1.gif) top left repeat-x; line-height: 30px;"><img style=" vertical-align: bottom;" src="<?php echo($dir) ?>images/live-chat_32.png" alt="<?php _e('Banckle Chat', 'Banckle Chat') ?>" /><span> Banckle Chat for WordPress</span></h3>

		  				<div class="inside" style="padding: 0 10px">
		  					 <table class="form-table">
		  						  <tr><td>
									 <?php
									 if (!function_exists('curl_init')) {
										  throw new Exception('Banckle Chat needs the CURL PHP extension.');
									 }
									 if (!function_exists('json_decode')) {
										  throw new Exception('Banckle Chat needs the JSON PHP extension.');
									 }


									 if (!get_option('BLCScript')) {
									 ?>
	 								</td></tr>
	 						  <tr valign="top">
	 								<td>
	 									 <div style="font-size:12px;">Banckle Chat Plugin has been successfully installed into your WordPress. To activate it, please visit <a target="_blank" href="http://banckle.com/wiki/display/livechat/integration-with-banckle-live-chat-wordpress-plugin-v.1.2.html">Integration with WordPress</a> page to follow a step-by-step tutorial with screenshots.</div>
	 								</td>
	 						  </tr>

	 						  <tr valign="top" style="padding-bottom:30px;">
	 								<td style="background:url(<?php echo($dir) ?>images/powered-by-banckle.gif) bottom right no-repeat; padding-bottom:60px;">
									 <?php
										  if (isset($_REQUEST['action']) && $_REQUEST['action'] === "deploy") {
												if ($_SERVER['REQUEST_METHOD'] == 'POST') {
													 $loginId = $_POST['loginId'];
                                                                                                         //echo "loginid:" . $loginId;
													 $password = $_POST['password'];
													 $token = $_POST['token'];
													 $deptId = $_POST['departments'];

													 $location = $_POST['blcLocation'];

													 $deployment = $_POST['deployment'];
													 $deployment = $deployment === "" ? "New Deployment" : $deployment;

													 $title = $_POST['title'];
													 $title = $title === "" ? "Live Chat" : $title;

													 $copyright = $_POST['copyright'];
													 $copyright = $copyright === "" ? "Copyright is reserved by Banckle." : $copyright;

													 $inviteMessage = $_POST['inviteMessage'];
													 $inviteMessage = $inviteMessage === "" ? "Do you have any questions?" : $inviteMessage;

													 $unavailableMessage = $_POST['unavailableMessage'];
													 $unavailableMessage = $unavailableMessage === "" ? "Sorry, our service is unavailable now." : $unavailableMessage;

													 $waitingMessage = $_POST['waitingMessage'];
													 $waitingMessage = $waitingMessage === "" ? "Please stand by while we connect you to the next available operator..." : $waitingMessage;

													 $welcomeMessage = $_POST['welcomeMessage'];
													 $welcomeMessage = $welcomeMessage === "" ? "Welcome to Banckle" : $welcomeMessage;

													 $finalMessage = $_POST['finalMessage'];
													 $finalMessage = $finalMessage === "" ? "Thank you for choosing Banckle." : $finalMessage;

													 $deployXML = new SimpleXMLElement("<?xml version=\"1.0\" encoding=\"UTF-8\"?><deployment></deployment>");
													 $deployXML->addChild("name", $deployment);
													 $deployXML->addChild("theme", "Theme-4");
													 $deployXML->addChild("title", $title);
													 $deployXML->addChild("copyright", $copyright);
													 $deployXML->addChild("unavailableMessage", $unavailableMessage);
													 $deployXML->addChild("waitingMessage", $waitingMessage);
													 $deployXML->addChild("welcomeMessage", $welcomeMessage);
													 $deployXML->addChild("finalMessage", $finalMessage);
													 $deployXML->addChild("inviteMessage", $inviteMessage);
													 $deployXML->addChild("departments", $deptId);
													 $deployXML->addChild("exitSurvey", "");
													 $deployXML->addChild("enableAutoInvite", "false");
													 $deployXML->addChild("inviteTimeout", "60");
													 $deployXML->addChild("autoInviteImage", "");
													 $deployXML->addChild("enableProactiveInvite", "true");
													 //$deployXML->addChild("proactiveInviteImage","");
													 $deployXML->addChild("enableInvitationFilter", "false");
													 $deployXML->addChild("invitationFilterType", "0");
													 $deployXML->addChild("linkType", "0");
													 $deployXML->addChild("themeFlags", "0");

													 //echo $deployXML->asXML()."<hr>";
													 $xmlDeploy = banckleLiveChatRequest('https://chat.banckle.com/chat/api/deployments.xml?_token=' . $token, "POST", "XML", $deployXML->asXML());
													 //echo $xmlDeploy."<hr>";
													 $xmlDeploy = new SimpleXMLElement(utf8_encode($xmlDeploy));
									 ?>

													 <form method="post" action="options.php">
										  <?php wp_nonce_field('update-options'); ?>
		  										  <div class="wp-lc-deploy">
		  												<div style="width: 580px; padding: 5px; margin: 0px auto; line-height:26px">
		  													 <div class="row" style=" font-weight: normal;">
		  														  <b>Congratulations!</b> Banckle Chat Deployment Widget is <b>successfully</b> created.
		  													 </div>

		  													 <div class="row">
		  														  <span class="label">
		  																<input type="hidden" name="BLCScript" id="BLCScript" value="<?php echo $xmlDeploy->id; ?>"/>
		  																<input type="hidden" name="loginId" id="loginId" value="<?php echo $loginId ?>"/>
		  																<input type="hidden" name="password" id="password"  value="<?php echo $password ?>"/>
		  																<input type="hidden" name="blcLocation" id="blcLocation" value="<?php echo $location ?>"/>
		  																<input type="hidden" name="action" value="update" />
		  																<input type="hidden" name="page_options" value="BLCScript,loginId,password,blcLocation" />&nbsp;
		  														  </span>
		  														  <span class="formw"><input style="margin-top:8px" type="submit" class="button-primary" value="<?php _e('Activate Live Chat') ?>" /></span>
		  													 </div>
		  												</div>
		  										  </div>
		  									 </form>
									 <?php
												}
										  }
										  if (isset($_REQUEST['action']) && $_REQUEST['action'] === "dept") {
												if ($_SERVER['REQUEST_METHOD'] == 'POST') {
													 $loginId = $_POST['loginId'];
                                                                                                         //echo "loginid: " . $loginId;
													 $password = $_POST['password'];
													 $dept = $_POST['deptName'];
													 $deptId = isset($_POST['deptId']) ? $_POST['deptId'] : null;
													 $dept = $dept === "" ? "New Department" : $dept;
													 $token = '';

													 $arr;
													 $content = banckleLiveChatRequest('https://apps.banckle.com/api/authenticate?userid=' . $loginId . '&password=' . $password . '&sourceSite=' . get_bloginfo('wpurl') . '&platform=wordpress', "GET", "JSON", "");

													 //echo $content . '<br><br>';
													 if ($content !== false) {
														  $arr = json_decode($content, true);
														  if (array_key_exists('error', $arr)) {
									 ?><div class="wp-lc-error">Oops, <?php echo $arr['error']['details']; ?>.<br/><input style="margin-top:8px;" type="submit" class="button-primary" onclick="parent.location='options-general.php?page=banckle-live-chat-for-wordpress'" value="<?php _e('Try Again') ?>" /></div><?php
														  } else {
																$token = $arr['return']['token'];
																if (!isset($deptId)) {
																	 $jsonDept = banckleLiveChatRequest('https://chat.banckle.com/chat/api/departments.js?_token=' . $token, "POST", "JSON", '{displayName : "' . $dept . '", members : ["' . $loginId . '"]}');
																	 $jsonDeptArray = json_decode($jsonDept, true);
																	 if (array_key_exists('id', $jsonDeptArray)) {
																		  $deptId = $jsonDeptArray['id'];
																	 }
																}
																if ($deptId === "") {
									 ?><div class="wp-lc-error">Oops <?php echo $jsonDept; ?>, Department is not created, Please <br/><input style="margin-top:8px;" type="submit" class="button-primary" onclick="parent.location='options-general.php?page=banckle-live-chat-for-wordpress&action=dept'" value="<?php _e('Try Again') ?>" /></div><?php
																} else {
																	 BanckleLiveChatDeploymentForm($deptId, $dept, $token, $loginId, $password);
																}
														  }
													 }
												}//end action dept post
										  }//end action dept
										  if (isset($_REQUEST['action']) && $_REQUEST['action'] === "signup") {
												if ($_SERVER['REQUEST_METHOD'] == 'POST') {
													 $loginId = $_POST['email'];
													 $password = $_POST['password'];
													 $email = $_POST['email'];

													 $arr;
													 $content = banckleLiveChatRequest('https://apps.banckle.com/api/registeruser?password=' . $password . '&email=' . $email, "GET", "JSON", "");
													 if ($content !== false) {
														  $arr = json_decode($content, true);
														  //var_dump($arr);
														  if (array_key_exists('error', $arr)) {
																//
									 ?>
					 									 <div class="wp-lc-error">
					 																														Oops, <?php echo $arr['error']['details']; ?>.<br/>
					 										  <input style="margin-top:8px;" type="submit" class="button-primary" onclick="parent.location='options-general.php?page=banckle-live-chat-for-wordpress&action=signup'" value="<?php _e('Try Again') ?>" />
					 									 </div>
									 <?php
														  } else {
									 ?>
						  									 <div class="wp-lc-login-form-error">Your Banckle account has been created successfully.</div>
						  									 <form method="post" action="options-general.php?page=banckle-live-chat-for-wordpress&action=dept">
						  										  <div class="wp-lc-login">
						  												<div style="width: 580px; padding: 5px; margin: 0px auto; line-height:26px;">
						  													 <div class="row">
						  														  <span class="label"><label>Department:</label></span>
						  														  <span class="formw"><input type="text" name="deptName" id="deptName" style="width:275px"/></span>
						  														  <input type="hidden" name="loginId" id="loginId" style="width:275px" value="<?php echo $loginId ?>"/>
						  														  <input type="hidden" name="password" id="password"  style="width:275px" value="<?php echo $password ?>"/>
						  													 </div>
						  													 <div class="row">
						  														  <span class="label">&nbsp;</span>
						  														  <span class="formw"><input type="submit" class="button-primary" value="Create Department" /></span>
						  													 </div>
						  												</div>

						  										  </div>
						  									 </form>
									 <?php
														  }
													 }
												} else {
													 //}
									 ?>
													 <form method="post" action="options-general.php?page=banckle-live-chat-for-wordpress&action=signup">
														  <div class="wp-lc-login">
																<div style="width: 580px; padding: 5px; margin: 0px auto; line-height:26px;">
																	 <!--div class="row">
																		  <span class="label"><label>Banckle Login ID:</label></span>
																		  <span class="formw"><input type="text" name="loginId" id="loginId" style="width:275px"/></span>
																	 </div-->
																	 <div class="row">
																		  <span class="label"><label>Email:</label></span>
																		  <span class="formw"><input type="text" name="email" id="email"  style="width:275px"/></span>
																	 </div>                                                                                                                                         
																	 <div class="row">
																		  <span class="label"><label>Password:</label></span>
																		  <span class="formw"><input type="password" name="password" id="password"  style="width:275px"/></span>
																	 </div>
																	 <div class="row">
																		  <span class="label">&nbsp;</span>
																		  <span class="formw"><input type="submit" class="button-primary" value="Register" /> <span><a href="options-general.php?page=banckle-live-chat-for-wordpress">Sign In</a></span></span>
																	 </div>
																</div>

														  </div>
													 </form>
									 <?php
												}
										  } else {
												if (!isset($_REQUEST['action']))
													 if ($_SERVER['REQUEST_METHOD'] == 'POST') {

														  $loginId = $_POST['loginId'];
														  $password = $_POST['password'];
														  $token = '';
														  $arr;
														  $content = banckleLiveChatRequest('https://apps.banckle.com/api/authenticate?userid=' . $loginId . '&password=' . $password . '&sourceSite=' . get_bloginfo('wpurl') . '&product=livechat&platform=wordpress', "GET", "JSON", "");

														  //echo $content . '<br><br>';
														  if ($content !== false) {
																$arr = json_decode($content, true);
																//var_dump($arr);

																if ($arr === null || array_key_exists('error', $arr)) {
																	 if($arr === null){
																		  echo '<div class="wp-lc-error">Oops! This user ID does not exist. <br/><input style="margin-top:8px;" type="submit" class="button-primary" onclick="parent.location=\'options-general.php?page=banckle-live-chat-for-wordpress\'" value="Try Again" /></div>';
																	 }else{
									 ?>
																		  <div class="wp-lc-error">Oops! <?php echo $arr['error']['details']; ?><br/><input style="margin-top:8px;" type="submit" class="button-primary" onclick="parent.location='options-general.php?page=banckle-live-chat-for-wordpress'" value="<?php _e('Try Again') ?>" /></div>


									 <?php
																	 }
																} else {
																	 //var_dump($arr);
																	 $token = $arr['return']['token'];

																	 //Get the XML document loaded into a variable
																	 $xmlDept = banckleLiveChatRequest('https://chat.banckle.com/chat/api/departments.xml?_token=' . $token, "GET", "XML", "");

																	 $xmlDept = new SimpleXMLElement(utf8_encode($xmlDept));

																	 //if ($xmlDept->count() <= 0 || $xmlDept->department[0]->id == "") {
																	 if (count($xmlDept->department) == 0) {
									 ?>

									 									 <form method="post" action="options-general.php?page=banckle-live-chat-for-wordpress&action=dept">
									 										  <div class="wp-lc-login">
									 												<div style="width: 580px; padding: 5px; margin: 0px auto; line-height:26px;">
									 													 <div class="row" style=" font-weight: normal; text-align: left;margin-left: 75px;">
									 														  <b>It seems you have not created a department yet.</b> Its easy! So lets create a department now.
									 													 </div>
									 													 <div class="row">
									 														  <span class="label"><label>Department:</label></span>
									 														  <span class="formw"><input type="text" name="deptName" id="deptName" style="width:275px"/></span>
									 														  <input type="hidden" name="loginId" id="loginId" style="width:275px" value="<?php echo $loginId ?>"/>
									 														  <input type="hidden" name="password" id="password"  style="width:275px" value="<?php echo $password ?>"/>
									 													 </div>
									 													 <div class="row">
									 														  <span class="label">&nbsp;</span>
									 														  <span class="formw"><input type="submit" class="button-primary" value="Create Department" /></span>
									 													 </div>
									 												</div>

									 										  </div>
									 									 </form>
									 <?php
																	 } else {


																		  //Get the XML document loaded into a variable
																		  $xmlDeploy = banckleLiveChatRequest('https://chat.banckle.com/chat/api/deployments.xml?_token=' . $token, "GET", "XML", "");

																		  $xmlDeploy = new SimpleXMLElement(utf8_encode($xmlDeploy));
																		  if (count($xmlDeploy->deployment) > 0) {
									 ?>


										  									 <form method="post" action="options.php">
										  <?php wp_nonce_field('update-options'); ?>
									 										  <div class="wp-lc-deploy">

									 												<div style="width: 580px; padding: 5px; margin: 0px auto; line-height:26px">
									 													 <div class="row">
									 														  <span class="label"><label>Select Deployment:</label></span>
									 														  <span class="formw">
									 																<select id="BLCScript" name="BLCScript"  style="width:140px">
																	 <?php
																				for ($i = 0; $i < count($xmlDeploy->deployment); $i++) {
																					 echo '<option value="' . $xmlDeploy->deployment[$i]->id . '">' . $xmlDeploy->deployment[$i]->name . '</option>';
																				}
																	 ?>
		  																</select>
		  														  </span>
		  													 </div>
		  													 <div class="row">
		  														  <span class="label">
		  															  <!--input type="hidden" name="BLCScript" id="BLCScript" value="<?php echo $xmlDeploy->deployment[0]->id; ?>"/-->
		  																<input type="hidden" name="loginId" id="loginId" value="<?php echo $loginId ?>"/>
		  																<input type="hidden" name="password" id="password"  value="<?php echo $password ?>"/>
		  																<input type="hidden" name="deptId" id="deptId"  value="<?php echo $xmlDeploy->deployment[0]->departments ?>"/>
		  																<input type="hidden" name="action" value="update" />
		  																<input type="hidden" name="page_options" value="BLCScript,loginId,password,deptId" />&nbsp;
		  														  </span>
		  														  <span class="formw"><input style="margin-top:8px" type="submit" class="button-primary" value="<?php _e('Activate Live Chat') ?>" /></span>
		  													 </div>
		  												</div>

		  										  </div>
		  									 </form>
									 <?php
																		  } else {
									 ?>
										  									 <form method="post" action="options-general.php?page=banckle-live-chat-for-wordpress&action=dept">
										  										  <div class="wp-lc-login">
										  												<div style="width: 580px; padding: 5px; margin: 0px auto; line-height:26px;">
										  													 <div class="row" style=" font-weight: normal; text-align: left;margin-left: 75px;">
										  														  <b>It seems you have not added a deployment yet.</b> Its easy! So lets add a deployment.
										  													 </div>
										  													 <div class="row">
										  														  <input type="hidden" name="deptId" id="deptId" style="width:275px" value="<?php echo $xmlDept->department[0]->id ?>"/>
										  														  <input type="hidden" name="deptName" id="deptName" style="width:275px" value="<?php echo $xmlDept->department[0]->displayName ?>"/>
										  														  <input type="hidden" name="loginId" id="loginId" style="width:275px" value="<?php echo $loginId ?>"/>
										  														  <input type="hidden" name="password" id="password"  style="width:275px" value="<?php echo $password ?>"/>
										  													 </div>
										  													 <div class="row">
										  														  <span class="label">&nbsp;</span>
										  														  <span class="formw"><input type="submit" class="button-primary" value="Create Deployment" /></span>
										  													 </div>
										  												</div>
										  										  </div>
										  									 </form>
									 <?php
																		  }//ends deployments
																	 }// ends departments
																	 //echo '<br><b>' . $token . '</b><br>';
																}// ends user auth.
														  }// end if contents got from banclke
														  else {
																echo "Network Error";
														  }
													 } else {
									 ?>

					 									 <form method="post" action="options-general.php?page=banckle-live-chat-for-wordpress">
					 										  <div class="wp-lc-login">


					 												<div style="width: 580px; padding: 5px; margin: 0px auto; line-height:26px;">
					 													 <div class="row">
					 														  <span class="label"><label>Banckle Login ID:</label></span>
					 														  <span class="formw"><input type="text" name="loginId" id="loginId" style="width:275px"/></span>
					 													 </div>
					 													 <div class="row">
					 														  <span class="label"><label>Password:</label></span>
					 														  <span class="formw"><input type="password" name="password" id="password"  style="width:275px"/></span>
					 													 </div>
					 													 <div class="row">
					 														  <span class="label">&nbsp;</span>
					 														  <span class="formw"><input type="submit" class="button-primary" value="Continue" /></span>
					 													 </div>
					 													 <div class="row">
					 														  <span>Don't have a Banckle account? Please <a href="options-general.php?page=banckle-live-chat-for-wordpress&action=signup">Sign up.</a></span>
					 													 </div>
					 												</div>

					 										  </div>
					 									 </form>
									 <?php
													 }// ends ispostback check






													 
										  }// ends action check
									 ?>
	 								</td></tr>
						  <?php
									 } else {
										  if (isset($_REQUEST['action']) && $_REQUEST['action'] === "updateDeploy") {

												$loginId = $_POST['loginId'];
												$password = $_POST['password'];
												$token = $_POST['token'];
												$deployId = $_POST['deployId'];
												$deployment = $_POST['deployment'];
												$departments = $_POST['departments'];
												$title = $_POST['title'];
												$copyright = $_POST['copyright'];
												$inviteMessage = $_POST['inviteMessage'];
												$unavailableMessage = $_POST['unavailableMessage'];
												$waitingMessage = $_POST['waitingMessage'];
												$welcomeMessage = $_POST['welcomeMessage'];
												$alertInvalidEmail = $_POST['alertInvalidEmail'];
												$alertMessageSent = $_POST['alertMessageSent'];
												$alertConnectionFailed = $_POST['alertConnectionFailed'];
												$messageEnterYourName = $_POST['messageEnterYourName'];
												$messageSwitchToOffline = $_POST['messageSwitchToOffline'];
												$messageOnlineImageTip = $_POST['messageOnlineImageTip'];
												$messageOfflineImageTip = $_POST['messageOfflineImageTip'];
												$messageProactiveInvite = $_POST['messageProactiveInvite'];
												$messageNoOnlineOperator = $_POST['messageNoOnlineOperator'];
												$messageChangeToOffline = $_POST['messageChangeToOffline'];
												$finalMessage = $_POST['finalMessage'];
												$alertInvalidMessage = $_POST['alertInvalidMessage'];
												$location = $_POST['blcLocation'];

												$deployXML = new SimpleXMLElement("<?xml version=\"1.0\" encoding=\"UTF-8\"?><deployment></deployment>");
												$deployXML->addChild("name", $deployment);
												$deployXML->addChild("theme", "Theme-4");
												$deployXML->addChild("title", $title);
												$deployXML->addChild("copyright", $copyright);
												$deployXML->addChild("unavailableMessage", $unavailableMessage);
												$deployXML->addChild("waitingMessage", $waitingMessage);
												$deployXML->addChild("welcomeMessage", $welcomeMessage);
												$deployXML->addChild("alertInvalidEmail", $alertInvalidEmail);
												$deployXML->addChild("alertMessageSent", $alertMessageSent);
												$deployXML->addChild("alertConnectionFailed", $alertConnectionFailed);
												$deployXML->addChild("messageEnterYourName", $messageEnterYourName);
												$deployXML->addChild("messageSwitchToOffline", $messageSwitchToOffline);
												$deployXML->addChild("messageOnlineImageTip", $messageOnlineImageTip);
												$deployXML->addChild("messageOfflineImageTip", $messageOfflineImageTip);
												$deployXML->addChild("messageProactiveInvite", $messageProactiveInvite);
												$deployXML->addChild("messageNoOnlineOperator", $messageNoOnlineOperator);
												$deployXML->addChild("messageChangeToOffline", $messageChangeToOffline);
												$deployXML->addChild("finalMessage", $finalMessage);
												$deployXML->addChild("alertInvalidMessage", $alertInvalidMessage);
												$deployXML->addChild("inviteMessage", $inviteMessage);
												$deployXML->addChild("exitSurvey", "");
												$deployXML->addChild("enableAutoInvite", "false");
												$deployXML->addChild("inviteTimeout", "60");
												$deployXML->addChild("autoInviteImage", "");
												$deployXML->addChild("enableProactiveInvite", "true");
												$deployXML->addChild("enableInvitationFilter", "false");
												$deployXML->addChild("invitationFilterType", "0");
												$deployXML->addChild("linkType", "0");
												$deployXML->addChild("themeFlags", "0");

												$xmlDeploy = banckleLiveChatRequest('https://chat.banckle.com/chat/api/deployments/' . $deployId . '.xml?_token=' . $token, "PUT", "XML", $deployXML->asXML());


												//$contents = banckleLiveChatRequest($url	, "PUT", "JSON", $strJson);
												//echo 'contents:'.$contents;
												//$xmlDeploy = new SimpleXMLElement(utf8_encode($xmlDeploy));

												update_option('blcLocation', $location);

												echo '<div class="wp-lc-mesg-success">Deployment is updated!<br><input type="button" class="button-primary" value="OK" onclick="parent.location=\'options-general.php?page=banckle-live-chat-for-wordpress\'" /></div>';

												/*
												  ?>

												  <form method="post" action="options.php">
												  <?php wp_nonce_field('update-options'); ?>
												  <div class="wp-lc-deploy">
												  <div style="width: 580px; padding: 5px; margin: 0px auto; line-height:26px">
												  <div class="row">
												  Deployment is updated successfully!
												  </div>

												  <div class="row">
												  <span class="label">
												  <input type="hidden" name="blcLocation" id="blcLocation" value="<?php echo $location ?>"/>
												  <input type="hidden" name="action" value="update" />
												  <input type="hidden" name="page_options" value="blcLocation" />&nbsp;
												  </span>
												  <span class="formw"><input style="margin-top:8px" type="submit" class="button-primary" value="<?php _e('Ok') ?>" /></span>
												  </div>
												  </div>
												  </div>
												  </form>
												  <?php
												 */
										  }
										  if (isset($_REQUEST['action']) && $_REQUEST['action'] === "custom") {
												$loginId = get_option('loginId');
												$password = get_option('password');
												if(isset($_REQUEST['deployid']) && !empty($_REQUEST['deployid']) )
												{
													$deployId = $_REQUEST['deployid'];
												}
												else
												{
													$deployId = get_option('BLCScript');
												}
												
												$content = banckleLiveChatRequest('https://apps.banckle.com/api/authenticate?userid=' . $loginId . '&password=' . $password . '&sourceSite=' . get_bloginfo('wpurl') . '&platform=wordpress', "GET", "JSON", "");

												if ($content !== false) {
													 $arr = json_decode($content, true);

													 if (array_key_exists('error', $arr)) {
						  ?>
														  <div class="wp-lc-error">Oops, <?php echo $arr['error']['details']; ?>.<br/><input style="margin-top:8px;" type="submit" class="button-primary" onclick="parent.location='options-general.php?page=banckle-live-chat-for-wordpress'" value="<?php _e('Try Again') ?>" /></div>

						  <?php
													 } else {
														  //var_dump($arr);		
                              $token = $arr['return']['token'];                              
														  $xmlDeploy = banckleLiveChatRequest('https://chat.banckle.com/api/v2.0/deployments.xml?token=' . $token, "GET", "XML", "");
														  $xmlDeploy = json_decode($xmlDeploy);
														  $xmlDeploy->deployment = $xmlDeploy->{'return'};
														  unset($xmlDeploy->{'return'});
														  
														  $blcLocationWidget = ""; 
														  $blcLocationTopLeft = ""; 
														  $blcLocationTopRight = "";
														  $blcLocationBottomLeft = "";
														  $blcLocationBottomRight = "";
                                                                                                                  
                                                                                                                 														  
														  if(strcmp(get_option('blcLocation'),"banckleLiveChatWidget") == 0 ){
														      $blcLocationWidget = "selected=\"selected\"";
														  }
                                                                                                                  if(strcmp(get_option('blcLocation'), "banckleLiveChatTopLeft") == 0){
														      $blcLocationTopLeft = "selected=\"selected\"";
											  			  }
                                                                                                                  if(strcmp(get_option('blcLocation'), "banckleLiveChatTopRight") == 0){
														      $blcLocationTopRight = "selected=\"selected\"";
														  }
                                                                                                                  if(strcmp(get_option('blcLocation'), "banckleLiveChatBottomLeft") == 0){
														      $blcLocationBottomLeft = "selected=\"selected\"";
														  }
                                                                                                                  if(strcmp(get_option('blcLocation'), "banckleLiveChatBottomRight") == 0){
														      $blcLocationBottomRight = "selected=\"selected\"";
														  }		

						  ?>
														
														  <form method="post" action="options-general.php?page=banckle-live-chat-for-wordpress&action=updateDeploy">
																<div class="wp-lc-login-form">
																	 <div class="wp-lc-login-form-btm">
																		  <div style="width: 580px; padding: 5px; margin: 0px auto; line-height:26px;">
																				<fieldset>
																					 <legend>Deployment</legend>
																					 <div class="row">
																						  <span class="label"><label>Deployment:</label></span>																						  
                                                                                                                                                                                  <span class="formw"><select name="deployment" id="deployment">
                                                                                                                                                                                  <?php
                                                                                                                                                                                    for($i=0; $i < count($xmlDeploy->deployment);++$i){
																																														if($xmlDeploy->deployment[$i]->id == $deployId){ $selected = 'selected="selected"'; } else { $selected = ''; }
                                                                                                                                                                                        echo "<option $selected value='".$xmlDeploy->deployment[$i]->name."' id='".$xmlDeploy->deployment[$i]->id."' >".$xmlDeploy->deployment[$i]->name."</option>";
                                                                                                                                                                                    }
                                                                                                                                                                                  ?>
                                                                                                                                                                                  </select></span>
                                                                                                                                                                                  
                                                                                                                                                                                  <!--span class="formw"><input type="text" name="deployment" id="deployment" style="width:275px" value="<?php echo $xmlDeploy->deployment[0]->name; ?>"/-->
                                                                                                                                                                                  <!--span class="formw"><select name="deployment" id="deployment"><option selected="<?php echo $blcLocationWidget ?>" value="banckleLiveChatWidget">Widget</option><option selected="<?php echo $blcLocationTopLeft ?>" value="banckleLiveChatTopLeft">Top Left</option><option  selected="<?php echo $blcLocationTopRight ?>" value="banckleLiveChatTopRight">Top Right</option><option selected="<?php echo $blcLocationBottomLeft ?>" value="banckleLiveChatBottomLeft">Bottom Left</option><option  selected="<?php echo $blcLocationBottomRight ?>" value="banckleLiveChatBottomRight">Bottom Right</option></select> </span-->
																					 </div>
																					 <div class="row">
																						  <span class="label"><label>Title:</label></span>
																						  <span class="formw"><input type="text" name="title" id="title" style="width:275px"  value="<?php echo $xmlDeploy->deployment[0]->widgetTitle; ?>"/></span>
																					 </div>
																					 <div class="row">
																						  <span class="label"><label>Copyright Text:</label></span>
																						  <span class="formw"><input type="text" name="copyright" id="copyright" style="width:275px"  value="<?php echo $xmlDeploy->deployment[0]->copyright; ?>"/></span>
																					 </div>
																				</fieldset>
																				<fieldset>
																					 <legend>Messages</legend>
																					 <div class="row">
																						  <span class="label"><label>Welcome:</label></span>
																						  <span class="formw"><textarea name="welcomeMessage" id="welcomeMessage" style="width:275px"><?php echo $xmlDeploy->deployment[0]->welcomeMessage; ?></textarea></span>
																					 </div>
																					 <div class="row">
																						  <span class="label"><label>Invite:</label></span>
																						  <span class="formw"><textarea name="inviteMessage" id="inviteMessage" style="width:275px"><?php echo $xmlDeploy->deployment[0]->inviteMessage; ?></textarea></span>
																					 </div>
																					 <div class="row">
																						  <span class="label"><label>Online:</label></span>
																						  <span class="formw"><textarea name="welcomeMessage" id="welcomeMessage" style="width:275px"><?php echo $xmlDeploy->deployment[0]->welcomeMessage; ?></textarea></span>
																					 </div>
																					 <div class="row">
																						  <span class="label"><label>Offline:</label></span>
																						  <span class="formw"><textarea name="unavailableMessage" id="unavailableMessage" style="width:275px"><?php echo $xmlDeploy->deployment[0]->unavailableMessage; ?></textarea></span>
																					 </div>
																					 <div class="row">
																						  <span class="label"><label>Waiting:</label></span>
																						  <span class="formw"><textarea name="waitingMessage" id="waitingMessage" style="width:275px"><?php echo $xmlDeploy->deployment[0]->waitingMessage; ?></textarea></span>
																					 </div>
																					 <div class="row">
																						  <span class="label"><label>Message:</label></span>
																						  <span class="formw"><textarea name="alertInvalidMessage" id="alertInvalidMessage" style="width:275px"><?php echo $xmlDeploy->deployment[0]->alertInvalidMessage; ?></textarea></span>
																					 </div>
																					 <div class="row">
																						  <span class="label"><label>Invalid Email:</label></span>
																						  <span class="formw"><textarea name="alertInvalidEmail" id="alertInvalidEmail" style="width:275px"><?php echo $xmlDeploy->deployment[0]->alertInvalidEmail; ?></textarea></span>
																					 </div>
																					 <div class="row">
																						  <span class="label"><label>Email Sent:</label></span>
																						  <span class="formw"><textarea name="alertMessageSent" id="alertMessageSent" style="width:275px"><?php echo $xmlDeploy->deployment[0]->alertMessageSent; ?></textarea></span>
																					 </div>
																					 <div class="row">
																						  <span class="label"><label>Connection:</label></span>
																						  <span class="formw"><textarea name="alertConnectionFailed" id="alertConnectionFailed" style="width:275px"><?php echo $xmlDeploy->deployment[0]->alertConnectionFailed; ?></textarea></span>
																					 </div>
																					 <div class="row">
																						  <span class="label"><label>Name:</label></span>
																						  <span class="formw"><textarea name="messageEnterYourName" id="messageEnterYourName" style="width:275px"><?php echo $xmlDeploy->deployment[0]->messageEnterYourName; ?></textarea></span>
																					 </div>
																					 <div class="row">
																						  <span class="label"><label>Switch To Offline:</label></span>
																						  <span class="formw"><textarea name="messageSwitchToOffline" id="messageSwitchToOffline" style="width:275px"><?php echo $xmlDeploy->deployment[0]->messageSwitchToOffline; ?></textarea></span>
																					 </div>
																					  <div class="row">
																						  <span class="label"><label>Online Image Tip:</label></span>
																						  <span class="formw"><textarea name="messageOnlineImageTip" id="messageOnlineImageTip" style="width:275px"><?php echo $xmlDeploy->deployment[0]->messageOnlineImageTip; ?></textarea></span>
																					 </div>
																					 <div class="row">
																						  <span class="label"><label>Offline Image Tip:</label></span>
																						  <span class="formw"><textarea name="messageOfflineImageTip" id="messageOfflineImageTip" style="width:275px"><?php echo $xmlDeploy->deployment[0]->messageOfflineImageTip; ?></textarea></span>
																					 </div>
																					 <div class="row">
																						  <span class="label"><label>Proactive Invite:</label></span>
																						  <span class="formw"><textarea name="messageProactiveInvite" id="messageProactiveInvite" style="width:275px"><?php echo $xmlDeploy->deployment[0]->messageProactiveInvite; ?></textarea></span>
																					 </div>
																					  <div class="row">
																						  <span class="label"><label>No Online Operator:</label></span>
																						  <span class="formw"><textarea name="messageNoOnlineOperator" id="messageNoOnlineOperator" style="width:275px"><?php echo $xmlDeploy->deployment[0]->messageNoOnlineOperator; ?></textarea></span>
																					 </div>
																					 <div class="row">
																						  <span class="label"><label>Change To Offline:</label></span>
																						  <span class="formw"><textarea name="messageChangeToOffline" id="messageChangeToOffline" style="width:275px"><?php echo $xmlDeploy->deployment[0]->messageChangeToOffline; ?></textarea></span>
																					 </div>
																					 <div class="row">
																						  <span class="label"><label>Exit:</label></span>
																						  <span class="formw"><textarea name="finalMessage" id="finalMessage" style="width:275px"><?php echo $xmlDeploy->deployment[0]->finalMessage; ?></textarea></span>
																					 </div>
																				</fieldset>
																				<fieldset>
																					 <legend>Appearance</legend>
																					 <div class="row">
																						  <span class="label"><label>Position</label></span>
																						  <span class="formw"><select name="blcLocation" id="blcLocation"><option <?php echo $blcLocationWidget ?> value="banckleLiveChatWidget">Widget</option><option <?php echo $blcLocationTopLeft ?> value="banckleLiveChatTopLeft">Top Left</option><option  <?php echo $blcLocationTopRight ?> value="banckleLiveChatTopRight">Top Right</option><option <?php echo $blcLocationBottomLeft ?> value="banckleLiveChatBottomLeft">Bottom Left</option><option <?php echo $blcLocationBottomRight ?> value="banckleLiveChatBottomRight">Bottom Right</option></select> </span>
																					 </div>
																				</fieldset>
																				<div class="row">
																					 <!--span class="label"><label>Department:</label></span-->
																					 <span class="formw">
																						  <input type="hidden" name="departments" id="departments" value="<?php echo $xmlDeploy->deployment[0]->departments; ?>" />
																						  <input type="hidden" name="loginId" id="loginId" style="width:275px" value="<?php echo $loginId; ?>"/>
																						  <input type="hidden" name="password" id="password"  style="width:275px" value="<?php echo $password; ?>"/>
																						  <input type="hidden" name="deployId" id="deployId"  style="width:275px" value="<?php echo $xmlDeploy->deployment[0]->id; ?>"/>
																						  <input type="hidden" name="token" id="token" value="<?php echo $token; ?>" style="width:275px"/>
                                                                                                                                                                                  <input type="hidden" name="page_options" value="BLCScript,loginId,password,deployId, blcLocation" />&nbsp;																	 
                                                                                                                                                                         </span>
																				</div>
																				<div class="row">
																					 <span class="label">&nbsp;</span>
																					 <span class="formw"><input type="submit" class="button-primary" value="Update Deployment" /><input type="button" class="button-primary" value="Cancel" onclick="parent.location='options-general.php?page=banckle-live-chat-for-wordpress'" /></span>
																				</div>

																		  </div><!--width 580px; -->
																	 </div><!--only for bottom bg -->
																</div><!--wp-lc-login-form -->
														  </form>
														  <script>
														  jQuery(document).ready(function(){
															jQuery('#deployment').change(function(){ 
																var deployId = jQuery('#deployment option:selected').attr('id');
																window.location = 'options-general.php?page=banckle-live-chat-for-wordpress&action=custom&deployid='+deployId;
															});
														  });
														  </script>
						  <?php
													 }
												}
										  }
										  if (!isset($_REQUEST['action']) || ((isset($_REQUEST['action']) && $_REQUEST['action'] === "deploy"))) {
						  ?>
					 						  <tr valign="top">
					 								<td style="background:url(<?php echo($dir) ?>images/powered-by-banckle.gif) bottom right no-repeat ; padding-bottom:60px">
					 									 <div class="wp-lc-mesg-success">
					 											Congratulations! Banckle Chat Plugin has been successfully integrated and activated for your WordPress website. Please sign into <a target="_blank" href="https://apps.banckle.com/livechat">Banckle Chat</a> to start chatting with your visitors.<br>
					 										  <form method="post" action="options.php" style="display:inline;">
<?php wp_nonce_field('update-options'); ?>
												<input type="hidden" name="BLCScript" id="BLCScript" value=""/>
												<input type="hidden" name="loginId" id="loginId" value=""/>
												<input type="hidden" name="password" id="password" value=""/>
												<input type="hidden" name="blcLocation" id="blcLocation" value=""/>
												<input type="hidden" name="action" value="update" />
												<input type="hidden" name="page_options" value="BLCScript,loginId,password,blcLocation" />
												<input style="margin-top:8px" type="submit" class="button-primary" value="<?php _e('Deactivate Live Chat') ?>" />
										  </form>
										  <form method="post" action="options-general.php?page=banckle-live-chat-for-wordpress&action=custom" style="display:inline;">
												<input type="hidden" name="loginId" id="loginId" value="<?php echo get_option('loginId') ?>"/>
												<input type="hidden" name="password" id="password" value="<?php echo get_option('password') ?>"/>
												<input type="hidden" name="deployId" id="deployId" value="<?php echo get_option('BLCScript') ?>"/>
												<input style="margin-top:8px" type="submit" class="button-primary" value="<?php _e('Customize Live Chat') ?>" />
										  </form>
									 </div>
								</td></tr>
						  <?php
										  } else {
												//if (isset($_REQUEST['action']) && $_REQUEST['action'] === "deploy") {
												//	header("location:".get_bloginfo ('wpurl')."/wp-admin/options-general.php?page=banckle-live-chat-for-wordpress");
												//}
										  }
									 }
								} catch (Exception $e) {
									 //echo 'Exception: ' . $e->getMessage();
									 if ($e->getMessage() === "String could not be parsed as XML") {
										  echo '<div class="wp-lc-login-form-error">Oops, Banckle Chat server is currently unavailable, Please try again later</div>';
									 } else {
										  if ($e->getMessage() === "String could not be parsed as XML") {

										  }else{
											echo '<div class="wp-lc-login-form-error"> Oops, [' . $e->getCode() . '] ' . $e->getMessage() . ' @ Line: ' . $e->getLine() . '</div>';
											}
									 }
								}
						  ?>

	 					 </table>
	 				</div>

	 		  </div>
	 	 </div>

	 </div>

<?php
								restore_error_handler();
						  }

						  add_submenu_page('options-general.php', 'Banckle Chat', '', 'manage_options', 'banckle-live-chat-for-wordpress', 'BanckleLiveChatSettings_page');
					 }
?>